import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class Chess_Clock_01 extends PApplet {/*
Current Version: 0.01
 Released:6.28.2007
 Creator: Che-Wei Wang http://cwwang.com
 License: GNU Public License
 Download Beta:
 To do: time delay, time control
 Instructions:
 click on circle to begin timer and select white player
 press 'UP' to increase time in minutes
 press 'DOWN' to decrease time
 press 'r' to reset
 press 'p' to pause
 press any key or click the mouse to toggle between black and white
 */


int pieSize;
int h,s1,s2;
int dif;
Clock c1,c2;
int time=5;
boolean pause=false;

public void setup()
{  
  dif=millis();
  size( screen.width, (screen.height) );
  setFullScreen( true );
  //setResolution( screen.width, screen.height );
  //frameRate(60);

  smooth();
  c1=new Clock(width*1/4,height/2);
  c2=new Clock(width*3/4,height/2);
} 


public void draw(){
  background(0);
  if(pause){
    fill(100,200);
    noStroke();
    rect(0,0,width,height) ;
  }
  else{
    if(c1.counting==false&&c2.counting==false){
      c1.startButton();
      c2.startButton(); 
      setTimer();
    }

    if(c2.counting){
      if(millis()-dif>=1000){
        s2=s2+1;
        dif=millis();
      }
    }

    else if (c1.counting){
      if(millis()-dif>=1000){
        s1=s1+1;
        dif=millis();
      }
    }
  }
  c1.init(time,s1);
  c2.init(time,s2);
}


public void setTimer(){

  for (int i=0;i<time;i++){
    if(time==3||time==5||time==25||time==60){
      stroke(120,20,0); 
    }

    else{
      stroke(100); 
    }

    noFill();
    if(i%5==0){

      strokeWeight(2);
    }
    else{

      strokeWeight(1);
    }

    timerPie(60,i,7,8);
    if(time>60){
      stroke(150);
      timerPie(60,constrain(i-60,0,60),8,9);
    }
    if(time>120){
      stroke(255);
      timerPie(60,constrain(i-120,0,60),9,10);
    }

    //ellipse(width/2,height/2,10+i*10,10+i*10);
  }
}

public void timerPie(float t, int d, int l1,int l2){

  pushMatrix();
  float angle=PI-(TWO_PI/t*d);
  translate(width/2,height/2);

  float x=sin(angle)*(width/2-width/5);
  float y=cos(angle)*(width/2-width/5);
  line(x/(l1),y/(l1),x/(l2),y/(l2));
  popMatrix();
}

public void keyReleased(){
  if(key=='r'){
    reset();
  }

  if(key=='p'&&pause==false){
    pause=true; 
  }
  else if(key=='p'&&pause==true){
    pause=false; 
  }
  if(pause==false){
    toggle();
  }

  if(c1.counting==false&&c2.counting==false){
    if (keyCode==UP){
      if (time<5){
        time++;
      }
      else{
        time=time+5;
      }
      if(time>=150){
        time=150;
      }
    }
    if (keyCode==DOWN){
      if (time<=5){

        time--;
      }
      else{
        time=time-5;
      }
      if(time<=1){
        time=1;
      }

    }
  }

}

public void toggle(){
  if(c1.counting){
    c1.counting=false;  
    c2.counting=true;    
  }

  else if(c2.counting){
    c2.counting=false;  
    c1.counting=true;    
  }
}


public void mousePressed(){
  toggle();
}

public void reset(){
  s1=0;
  s2=0;
  c1.init(time,0);
  c2.init(time,0);
  c1.counting=false;
  c2.counting=false;
  c1.white=false;
  c2.white=false;
}


public int h(){
  int hh;
  if (hour()>12) hh=hour()-12;
  else hh=hour();
  return hh ;
}

/**
 * FullScreen support for processing. 
 * 
 * For a detailed reference see http://www.superduper.org/processing/fullscreen_api/
 * 
 * - setFullScreen( true | false ) 
 *   goes to / leaves fullscreen mode
 *
 * - setResolution( x, y ) 
 *   sets the resolution 
 * 
 * - createFullScreenKeyBindings() 
 *   links ctrl+f (or apple+f for macintosh) to enter/leave fullscreen mode
 *
 * WARNING: This package conflicts with the processing "present" option. If you want
 * fullscreen from the start use like this: 
 * 
 * void setup(){
 *   setFullScreen( true );               // get fullscreen exclusive mode
 *   setResolution( 640, 480 );           // change resolution to 640, 480
 *   createFullScreenKeyBindings();       // let ctrl+f switch to window mode
 * }
 * 
 * LIMITATIONS: 
 * - The size of the sketch can not be changed, when your sketch is
 *   smaller than the screen it will be centered. 
 * - The ESC key exits the sketch, this is processing standard. 
 * - Requires min. Java 1.4 to be installed work
 * - Only works for applications (not for applets)
 * 
 * by hansi, http://www.superduper.org,  http://www.fabrica.it
 *
 */


// We use this frame to go to fullScreen mode...
Frame fsFrame = new Frame(); 
GraphicsDevice fsDevice = fsFrame.getGraphicsConfiguration().getDevice(); 
//AWTEventListener fsKeyListener;

// desired x/y resolution
int fsResolutionX, fsResolutionY; 

// the first time wait until the frame is displayed
boolean fsIsInitialized; 

// bind the keys? 
boolean fsBindKeys; 

// Setup everything...
{
  fsFrame.setTitle( "FullScreen" ); 
  fsFrame.setUndecorated( true ); 
  fsFrame.setBackground( Color.black ); 
  fsFrame.setLayout( null ); 
  fsFrame.addWindowListener( new FSWindowListener() );
  fsFrame.setSize( fsDevice.getDisplayMode().getWidth(), fsDevice.getDisplayMode().getHeight() ); 
}


/**
 * Are we in FullScreen mode? 
 *
 * @returns true if so, yes if not
 */
public boolean isFullScreen(){
  return fsDevice.getFullScreenWindow() == fsFrame; 
}


/**
 * FullScreen is only available is applications, not in applets! 
 *
 * @returns true if fullScreen mode is available
 */
public boolean isFullScreenAvailable(){
  return frame != null;
}

  
/**
 * Enters/Leaves fullScreen mode. 
 *
 * @param fullScreen true or false
 * @returns true on success
 */
public boolean setFullScreen( boolean fullScreen ){
  
  // If it's called from setup we wait until the applet initialized properly
  if( frameCount == 0 && fullScreen == true ){
    new FSWaitForInitThread().start(); 
    
    return true; 
  }
  
  
  
  
  
  if( fullScreen == isFullScreen() ){
    // no change required! 
    return true; 
  }
  else if( fullScreen ){
    // go to fullScreen mode...
    
    if( isFullScreenAvailable() ){
      fsDevice.setFullScreenWindow( fsFrame ); 
      
      // remove applet from processing frame and attach to fsFrame
      frame.removeAll(); 
      frame.setVisible( false ); 
      frame.setSize( width + frame.insets().left + frame.insets().right, 
                     height + frame.insets().top + frame.insets().bottom ); 
      fsFrame.add( this ); 
      this.requestFocus(); 
      
      // set nice resolution...
      setResolution( 0, 0 ); 
      
      
      return true; 
    }
    else{
      System.err.println( "Fullscreen mode not available" ); 
      return false; 
    }
  }
  else{
    // remove applet from fsFrame and attach to processing frame
    fsFrame.removeAll(); 
    frame.add( this ); 
    this.setLocation( frame.insets().left, frame.insets().top ); 
    this.requestFocus(); 
    
    fsDevice.setFullScreenWindow( null ); 
    fsFrame.setVisible( false ); 

    frame.setVisible( true ); 

    return true; 
  }
}


/**
 * Change display resolution. Only sets the resolution, use 
 * setFullScreen( true ) to go to fullscreen mode! 
 *
 * If you're not in fullscreen mode it memorizes the resolution and sets
 * it the next time you go in fullscreen mode
 *
 * @returns true if resolution change succeeded, false if not
 */
public boolean setResolution( int xRes, int yRes ){
  if( xRes > 0 && yRes > 0 ){
    fsResolutionX = xRes; 
    fsResolutionY = yRes; 
  }
  
  
  // only change in fullscreen mode
  if( !isFullScreen() ){
    return false; 
  }
  
  
  // Change resolution only if values are somehow meaningfull
  if( fsResolutionX <= 0 || fsResolutionY <= 0 ){
    setLocation( ( fsDevice.getDisplayMode().getWidth() - width ) / 2, ( fsDevice.getDisplayMode().getHeight() - height ) / 2 ); 
    return false; 
  }
  
  DisplayMode modes[ ] = fsDevice.getDisplayModes(); 
  DisplayMode theMode = null; 

  for( int i = 0; i < modes.length; i++ ){
    
    if( modes[ i ].getWidth() == fsResolutionX && modes[ i ].getHeight() == fsResolutionY ){
      theMode = modes[ i ]; 
    }
  }


  // Resolution not supported? 
  if( theMode == null ){
    System.err.println( "Display mode not supported: " + fsResolutionX + "x" + fsResolutionY ); 
    setLocation( ( fsDevice.getDisplayMode().getWidth() - width ) / 2, ( fsDevice.getDisplayMode().getHeight() - height ) / 2 ); 
    return false; 
  }


  // Wait until we are in fullScreen exclusive mode..
  try{
    fsDevice.setDisplayMode( theMode ); 
    fsFrame.setSize( fsResolutionX, fsResolutionY ); 
  }
  catch( Exception e ){
    System.err.println( "Failed to go to fullScreen mode" ); 
    e.printStackTrace(); 
    return false; 
  }

  setLocation( ( fsDevice.getDisplayMode().getWidth() - width ) / 2, ( fsDevice.getDisplayMode().getHeight() - height ) / 2 ); 
  return true; 
}



/**
 * Add keyboard short cuts (CTRL + F to toggle fullscreen mode)
 * Watch out - if you call this function twice weird things might happen! 
 */
public void createFullScreenKeyBindings(){
  fsBindKeys = true; 
}




final static int fsControlKey = Toolkit.getDefaultToolkit().getMenuShortcutKeyMask();

public void processKeyEvent( KeyEvent e ){
  
  // Are we allowed to look for key events? 
  if( fsBindKeys == false ){
    super.processKeyEvent( e ); 
  }
  
  // Catch the ESC key if in fullscreen mode
  else if( e.getKeyCode() == e.VK_ESCAPE ){
    if( isFullScreen() ){
      if( e.getID() == KeyEvent.KEY_RELEASED ){
        setFullScreen( false ); 
      }
    }
    else{
      super.processKeyEvent( e ); 
    }
  }
  
  // catch the cmd+f combination (alt+enter or ctrl+f for windows)
  else if( e.getID() == KeyEvent.KEY_PRESSED ){
    if( ( e.getKeyCode() == e.VK_F && e.getModifiers() == fsControlKey ) ||
        ( platform == WINDOWS && e.getKeyCode() == e.VK_ENTER && e.getModifiers() == e.VK_ALT ) ){
      // toggle fullscreen! 
      setFullScreen( !isFullScreen() ); 
    }
    else{
      super.processKeyEvent( e ); 
    }
  }
  else{
    super.processKeyEvent( e ); 
  }
}


/**
 * A window listener for the fullscreen window, that 
 * calls the exit() function of processing when the window 
 * is closed (using alt+f4, apple+w, or whatever)
 */
class FSWindowListener extends WindowAdapter{
  public void windowClosing( WindowEvent e ){
    // let processing exit! 
    exit(); 
  }
}



/**
 * A thread that invokes the setFullScreen() functionality delayed, 
 * in case it's called from setup()
 */
class FSWaitForInitThread extends Thread{
  
  public void run(){
    while( frameCount < 5 ){
      try{
        Thread.sleep( 1000 ); 
      }
      catch( Exception e ){
        System.err.println( "failed to go to fullscreen mode" ); 
        return; 
      }
    }
    
    if( !setFullScreen( true ) ){
      System.err.println( "failed to go to fullscreen mode" );
    }
  }
}

class Clock{
  int x;
  int y;
  boolean counting=false;
  boolean white=false;
  float w=width/60;
  int inc=1;
  Clock(int xx,int yy){
    x=xx;
    y=yy;
  }

  public void init(float mm, int ss){
    inc=constrain(PApplet.parseInt(mm/15),1,60);
    for (int i=ss;i<=mm*60;i=i+inc){ 
      pie(mm*60,i,2,3);

    }
    for (int i=ss;i<=mm*60;i=i+60){ 
      pie(mm*60,i,3,4);

    }




    if (white){
      fill(155);
      noStroke();
    }
    else{
      noFill();
      stroke(155);
      strokeWeight(3);

    }

    if (ss>mm*60){
      strokeWeight(3);
      stroke(255,0,0);
    }

    ellipse(x,y,w,w);
  }

  //void pie(total, incriment, linestart,lineend);
  public void pie(float t, int d, int l1,int l2){

    pushMatrix();
    float angle=PI-(TWO_PI/t*d);
    translate(x,y);
    if(counting){
      stroke(255/t*(d+1)+(l1),20/t*(d+1),255-255*(d+1)/t);
    }
    else{
      stroke(100);

    }
    float xx=sin(angle)*(width/2-width/5);
    float yy=cos(angle)*(width/2-width/5);
    strokeWeight(1);
    line(xx/(l1),yy/(l1),xx/(l2),yy/(l2));

    popMatrix();
  }



  public void startButton(){
    pushMatrix();
    fill(155);
    stroke(155);
    ellipse(x,y,w,w);
    popMatrix();
    if(mousePressed&&mouseX>x-w/2&&mouseX<x+w/2&&mouseY>y-w/2&&mouseY<y+w/2){
      reset();
      counting= true;
      white=true;
    }
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "Chess_Clock_01" });}}